// fs2: okulda:
// 1) mean avg prec implement edildi
// 2) ranked_eval.text de bazi print satirlari kaldirildi
// 3) TOPN 10 yapildi prec artti, recal dustu, ama mean avg hala %17 ya


// FS1; system for rankin querying
// pek cok sabit var, definelara dikkat et
// bazen gocuyo, tahminim blank line handle ederken olabilir...check et
// CEVAP: err_out ' a yazmaya calisiyomus, fs1 de duzeltildi, okulda.
// su an title+ desc + narr hanle ediyo
// TBD:
// 1) su short - long icin handling i ekle: hangi tagleri process edelim
// 2) bsearch not found bi saydir. kac case
// 3) boolean impement et!


// indexer5.c: read wordlist with CFC values
// compute tf*CFC for doc terms, normalize them and THEN add to index
// to do this, change index entries to be double, and add index function, too
// wordlist, entry ve dvector structurelara weight fieldi eklndi
// CFC weight wordlistten okuyup, term weighti tf*cfc oarak buluyo, dvece kaydediyo
// sonra dvec normalize edilip her bir term icin doc_id+weight_in_doc
// inveted indexe yaziliyo... Print alinan yerlerde falan da duzeltme oldu tabii
// CFC degisirse burada bi sey yapma. Tf veya nc degisirse bu kodda duzeltme gerekir
// unutma,son dvec outputa looptan sonra yazildigi icn 2 yerde duzeltme gerekiyo...

// indexer 3;
// read Wordlist file, read document vector, create the inverted index and
// write to a binarty file. Inverted entry lengths are known apriori.
// In this version, I'll use direct file access, mnext I'll use mem_map
// ONEMLI: Tum islemlerde index 1 den basliyo!!!!!!!!

// simdi mem_map yapabiliriz...
// large scalede bi deneyelim, unutma array length degisebilir
// tum document mem de tutuluyo degisik weighting kullanirsak diye...

//sigir49:
// 1) stems
// 2) sorts the wlist and makes two passes
// 3) for padding, we use -1
// 4) so doc no and term no starts from 1, does decrement by 1 while processing
// 5) if an indexed word could not found in the index due to stemming algorithm
// inconsitency, we do not exit, just print an error message...
// 6) ekrana kac word oldugu listte dogru olarak basiliyor...
// 7) Tum mesajlar bi error file a da yazdirilacak.. (buraya kadar sigir45 de ok)
// 8) In 47, I will use bseacrh and clean the code...So 46 is same as 45, as a backup
// In 47,some old code deleted, old arrays will be cleaned up to save mem
// And finally try to use bsearch in the second pass
// bsearch is ok, but be careful: WordList index is found using POINTER ARITHMETICS
// IN 48, word structure size azaltilacak...ok!
// IN 49, also return the max_rank, we may use in inverted list part!
// In 50, write wordlist simpler
// In 51, try to use the trie..

// sigir2.c: 1)long intler problem olabilir
// 2)second pass gerekirse sadece process relation icinde bir if le halledilir
// 3)birden fazla file isi...
// 4)doc size 10000, wordlist 100000, linesize 1000 unutma...
// 5)her seyi sanki R rel process edilir gibi, processingR=1 yaparak yapiyoz


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <math.h>
//#include <time.h> // sys vb. okul icin... see rfp
#include "ulib.h"

//#include <stem1.h>
//#include "f:\ir\project\inverted\btrie.h"
//#include "btrie.h"

#include "sglobal.h"

typedef struct vec {
       int index;
       double weight;
       } *VP, VectorComp;


typedef struct vec2 {
      VectorComp VecElement[1];
      int nonzero_elements;
      } Vector;



typedef struct doc_ve {
        long int index;
        char word[70];
        long int rank_in_doc;
        double term_weight; //INDEXER5
        long int address; // address of where to start reading;
        } DocVec, *DV;


typedef struct rec {
        char TName [1];
        char Cont_field [1];
        //char TDom [100];
        //char TSource [10];
        char tokens [1][3]; // to keep tokens in memory after tokenizing
        int token_no;
        char dc_token[1];

        double importance; // topic, source importance value
        double propogate_val; // here max. sim * importance but in general
        Vector *v;
        } *TP, Tuple;

typedef struct inv_ent {
        int doc_id;
        //int freq_in_doc;
        double weight;
        } InvEntry;

// In this version, I keep only the necessary structures for each word:
// namely; a_Word, occurrs_in_docs, CFCweight and disk_address

typedef struct words {
        char a_word[TOKEN_SIZE]; // for handling queries
        int occurs_in_docs; // to retrieve inv entires and also weight queries
        long int disk_address; // address to access in binary file
        double CFCweight; // CFC weight of the word
        } *WP, Word;

struct timeval *start_t, *end_t;
int elapsed_time;
struct timezone *tz;

ptimer process_time; // total time
double t_sum = 0;


Tuple rel_R [1]; // in these arrays assume keeping 2000 tuples of each relation
Tuple rel_S [1];

//Result Result_rel [1];

Word WordList[WORD_NO];
InvEntry buffer[BUFFERSIZE];

long int max_R, max_S; // no of tuples in R and S

int no_of_matches; // no of joined tuples
int no_of_comparisons; // no of compared tuples

double match_threshold = 0.5;

// these are here because i am so stupid that i could not pass them as arguments
double score;
int found = 0;
int word_no_in_list=0;

char stopwords[NOSTOPWORD][50] ; // to keep stop words

//double Vector1[WORD_NO]; // SIM9: will represent two tuples
//double Vector2[WORD_NO];

Vector *Vector1;
Vector *Vector2;

DocVec DVector[DOC_SIZE]; // to keep all term in a doc with dublications
int d_size=0; // length of current doc

long int doc_no = 0; // total no_of docs in all files


int trie_start = 0;
int err=0;

FILE * ifp, *j_ifp, *eval_out;
FILE * out, *d_out, *err_out, *out_2, *entry_out, *entry_ifp, *record_out;

char tName2[300];

int processing_R = 1;
int processing_S = 0;

char final_tokens [TOKEN_NO][TOKEN_SIZE];

typedef struct res {
        int doc_index;
        double sim_rank;
        } Result, *RP;


Result accumulator[DOC_NUM]; // accumulator array for partial similarities

// to keep top results found for each query
Result results [QUERY_NO][TOP_N];
Result temporary [TOP_N];

// to keep relevant results
int relevants[RELEVANT_SIZE];

// for purposes of statistics

int total_list_length = 0;
int total_node_access = 0;

int sum_list_length = 0;
int sum_node_access = 0;

//fs3...

typedef struct eval_str
        {
         double prec[TOP_N];
         double recall[TOP_N];
         } EvalStr;

typedef struct inter_eval_str
        {
         double prec[CUT_LEVEL];
         double recall[CUT_LEVEL];
         } InterStr;


EvalStr PR_values[QUERY_NO];

InterStr Interpolated_PR[QUERY_NO];

// remeber to initialize??
// allrel 0 olursa hic loopa girmez eval func da o yuzden bu arrayler initialize edilmeli


init_PR()
{
 int i, j;

 for (i=0; i<QUERY_NO; i++)
   for (j=0; j<TOP_N; j++)
   {
    PR_values[i].prec[j] = 0;
    PR_values[i].recall[j] = 0;
   }
}


init_Interpolated_PR()
{
 int i, j;

 for (i=0; i<QUERY_NO; i++)
   for (j=0; j<CUT_LEVEL; j++)
   {
    Interpolated_PR [i].prec[j] = 0;
    Interpolated_PR [i].recall[j] = 0;
   }
}



interpolate_PR()
{

   int i, j, k;
   double recall_level = 0.0;
   int start_index = 0;
   double max_prec= 0.0;
   int cut_no = 0;

   for (i=0; i<QUERY_NO; i++)
   {
        recall_level = 0.0;
        start_index = 0;
        max_prec = 0;
        cut_no = 0;


        while (recall_level <= 1.0) //&& start_index <TOP_N)
        {
          max_prec = 0.0;
          // onemli bu olmali

          while(PR_values[i].recall[start_index] < recall_level && start_index<TOP_N)
             start_index++;

          // eger esitsem o indexden basla, dillse looptan buyuk olarak cikti
          // 1 azalt!
          if (PR_values[i].recall[start_index] > recall_level && start_index >0 && start_index<TOP_N)
             start_index--;


          // find max from start index to top level
          for (k=start_index; k<TOP_N; k++)
              if (PR_values[i].prec[k] > max_prec)
                  max_prec = PR_values[i].prec[k];

             // if (i==2)
          //printf("max %lf\n", max_prec);


          Interpolated_PR[i].prec[cut_no] = max_prec;
          Interpolated_PR[i].recall[cut_no] = recall_level;
          //if (i==2)
            // printf("al %lf\n", Interpolated_PR[i].prec[cut_no]) ;


          recall_level += 0.1;
          cut_no ++;


        } //outer while

        // ciktiginda mesela baz leveller set edilmemisse onlar initializedan
        // 0 olacak

      } // end outer for
      //printf("ahhhhhhhaaaaa %lf\n",Interpolated_PR[2].prec[1]);

}

print_Interpolated_PR()
{

   int i, j;
   double sum;

   fprintf(eval_out, "\n");
   fprintf(eval_out, "11 POINT PR VALUES for all queries\n");
   fprintf(eval_out, "          ");
   for (j=0; j<CUT_LEVEL; j++)
        fprintf(eval_out,"%d        ", j+1);
   fprintf(eval_out, "\n");

           //printf("ahhhhhhhaaaaa %lf\n",Interpolated_PR[2].prec[1]);

   for (i=0; i<QUERY_NO; i++)
   {
       fprintf(eval_out,"q_no: %d",i);
       for (j=0; j<CUT_LEVEL; j++)
       {
        fprintf(eval_out," %lf", Interpolated_PR[i].prec[j]);
        //if (i==2)
        //printf("%lf\n",Interpolated_PR[i].prec[j]);
        fflush(out);
       }
       fprintf(eval_out, "\n");
   }

   fprintf(eval_out, "Av prec");
   for(j=0; j<CUT_LEVEL; j++)
   {
     sum = 0;
     for (i=0; i<QUERY_NO; i++)
         sum += Interpolated_PR[i].prec[j];

     fprintf(eval_out," %lf", sum/QUERY_NO);
   }

   fprintf(eval_out, "\n");



}


/////////////////////////////////////////////////////////////////////////

int separator(char ch)
{
  /*if (ch == ' ' || ch == ',' || ch == '\t')*/
  if (!isalnum(ch))
    return(1);
  else
    return(0);
}




// SIM11; changed strcmp !!! 30.04.2001
int FindStopIndex(int start,int end,char word[50])
{
  int length;
  int index;

  length=end-start+1;
  index=start+(length/2);

  if (length<=0)
    return (-1);
  else if (strcmp(word,stopwords[index])<0)
    return(FindStopIndex(start,index-1,word));
  else if (strcmp(word,stopwords[index])>0)
    return(FindStopIndex(index+1,end,word));
  else
    return(index);

}


// VECTOR functions

// compute vector length
double v_length(Vector *Vect)
{
 int i;
 double sum;

 sum = 0;

 for (i=0; i<Vect->nonzero_elements; i++)
     sum += Vect->VecElement[i].weight * Vect->VecElement[i].weight;

 return (sqrt(sum));
}


void v_normalize(Vector *v)
{
    int i;
    double length;

    length = v_length(v);


    for (i=0; i<v->nonzero_elements; i++)
         v->VecElement[i].weight = v->VecElement[i].weight/length;

}

/*
void v_normalize(double *Vector)
{
  int i;
  double length;

  length = v_length(Vector);


  for (i=0; i<WORD_NO; i++)
     Vector[i] = Vector[i] /length;

}
*/

double v_dotProduct(Vector *v1, Vector *v2)
{
  int i,k;
  double sum;
  sum = 0;

  // IMPORTANT: assuming each index appears only once in a vector

  for (i=0; i<v1->nonzero_elements; i++)
     for (k=0; k<v2->nonzero_elements; k++)
        if (v1->VecElement[i].index == v2->VecElement[k].index)
            {
            sum += v1->VecElement[i].weight * v2->VecElement[k].weight;
            //break; // by assumption, no index (word) is duplicate in a vector
            };



  //sum += v1[i]*v2[i];

  //printf("dot pro is %lf at comp %d\n",sum, no_of_comparisons);
  return (sum);


}

// compute the cosine of angle between two vectors
double v_VecCos( Vector *v1, Vector *v2)
{
  double t= v_dotProduct(v1, v2); // as i normalize, no need any more /(v_length(v1)*v_length(v2));
  fprintf(out, "dot %lf length %lf cos is %lf\n",v_dotProduct(v1, v2),v_length(v1)*v_length(v2), t);
  //fprintf(out,"cos is %lf\n", t);
  return t;

}

// linear search in the word list
// returns the index if the key is found
// and returns where to add if not found
int my_lsearch (char *key, Word *List)
{
  int i;

  i=0;
  printf("eeee \n");

  while (strcmp(List[i].a_word,"")!=0 && i<WORD_NO)
  {
    if (strcmp(List[i].a_word, key)==0)
       {
       found = 1;
       return i;
       }
    i++;
    printf("%d \n", i);
  }
  found = 0;
  return i;
}

int index_order(DV dvec1, DV dvec2)
{
   if (dvec1->index > dvec2->index)
      return 1;
   if (dvec1->index < dvec2->index)
      return -1;
   return 0;
}


int lex_order3(WP w1, WP w2)
{
  return strcmp(w1->a_word, w2->a_word);
}


int lex_order2(TP t1, TP t2)
{
  return strcmp(t1->tokens[0], t2->tokens[0]);
}

int lex_order(char *s1, char *s2)
{
  return strcmp(s1, s2);
}

int lex_order5(TP t1, TP t2)
{
  return strcmp(t1->dc_token, t2->dc_token);
}

// changed to provide decreasing order, compare with order func. below
int prop_order(TP t1, TP t2)
{
  if (t1->propogate_val > t2->propogate_val)
     return -1;
  if (t1->propogate_val < t2-> propogate_val)
     return 1;
  return 0;

}

/* I replaced '\0' with NULL in the below function */

void read_next_value(char *into)
{


  int j;
  int i;
  char tempo[300];

  //printf("tnmae is %s \n", tName2);
  i = 0;
  /* skip separators */
  while (separator(tName2[i]) && tName2[i] != NULL ) i++;

  j=0;
  while (!separator(tName2[i]) && tName2[i] != NULL) {
    into[j++]=tName2[i];
    i++;
  }
  into[j]=NULL; /* into contains a value as a string */

   /*
  j=0;
  while(tName2[i]!=NULL)
  {
     tName2[j]=tName2[i];
     i++;
     j++;
    }
 */

  //printf("tnmae is %s \n", tName2);
  j=0;
  while(tName2[i]!=NULL)
  {
     tempo[j]=tName2[i];
     i++;
     j++;
    }

  tempo[j] = NULL;
  strcpy(tName2, tempo);

  //printf("tnmae and tempo are %s %s \n", tName2, tempo);
} /* read_next_value */

/* this function would process TName field of a given tuple of a relation */
/* processing means tokenzing the words in the TName and locating these in the tokens*/
/* field of the relatipn */

void process_tuple(char *line, long int tuple_no)
{
 char *tName, *rName;
 int trie_key;

 char tokens[TOKEN_NO][TOKEN_SIZE];
 //char final_tokens [30][30];
 char str[300], temp[300], tmp[300];
 int token_found,i,q, tokens_left, index;

 //28 NOV
 WP word, sword;
 int add1, add2, word_size;

  //tName= (char*)malloc(sizeof(char)*30);
  //rName=tName;
  //strcpy(tName, Relation[p].TName);
 strcpy(tName2, line); // DO NOT change tName2, read_next_val ona gore yazilmis!!!
 //printf("look, tuple TName is :%s and length is %d\n", tName2, strlen(tName2)); // debugging


 // tokenize the TName field
 token_found = 0;
 read_next_value(str);


 while  (  *str != NULL)
 {

   strcpy(tokens[token_found],str);
   token_found++;
   read_next_value(str);
 }

 // omit the tokens that are found in the stop list
 tokens_left = 0;
 for (i=0; i<token_found; i++)
 {

    for (q=0; q<strlen(tokens[i]); q++)
         tokens[i][q] = tolower(tokens[i][q]);

    if (FindStopIndex(0,NOSTOPWORD-1,tokens[i]) == -1)
    {

     strcpy(tmp, tokens[i]);

     //NEW
     //if (!sec_pass)
     //{
     // question: does it stem identical in both passes?
     /*
     Stem(tokens[i]);

     if (strlen(tokens[i])==0)
        {
        strcpy(tokens[i], tmp);
        }
     */
     //}

     strcpy(final_tokens[tokens_left], tokens[i]);
     found=0;
        if (processing_R)
        {
         // Here, wordlist is sorted, so I prefer to use a bsearch
          //index=my_lsearch(tokens[i], WordList);
         /*if (index>word_no_in_list+1)
           { printf("nooluyo len\n");
           exit(1);}
           */
         // 28 NOV
         sword = (WP) malloc(sizeof(Word));
         // yeni koydum...
         word = (WP) malloc(sizeof(Word));

         if (sword == NULL)
         {  printf("could not allocate space\n");
            exit(1);
         }

         strcpy(sword->a_word,tokens[i]);
         //printf("%s ariyorum...\n", sword->a_word);
         word = (WP) bsearch(sword->a_word ,WordList, word_no_in_list+1, sizeof(WordList[0]), lex_order);

         if (word)
         {
            found = 1;
            // not sure if this is a good idea
            add1 = (int) WordList;
            //printf("array add. %d ", add1);
            add2 = (int) word;
            //printf("word add. %d ",add2);
            word_size = sizeof(Word);
            //printf("word %d\n", word_size);

            // Note that, the expression gives exactly the array index of WordList, starting from 0 of course
            //printf("al %s index %d rank %d\n",word->a_word,((add2-add1)/word_size), word->rank_R);
            index = (add2-add1)/word_size;

            free(sword);
         }
         else
         {    printf("bsearch could not found\n");
              //fprintf(err_out, "ERROR bsearch could not found\n");

         }

         if (found) // will be surely found!!!
         {

         // now add this term to the current doc vector
         strcpy(DVector[d_size].word, tokens[i]);
         DVector[d_size].index = index;
         //DVector[d_size].address = WordList[index].disk_address;
         d_size++;

            if (d_size>DOC_SIZE)
            {
             printf("Doc size exceeds %d!\n", DOC_SIZE);
             //fprintf(err_out,"ERROR Doc size exceeds %d!\n", DOC_SIZE);
             exit(1);
            }

         } // if_found
         else // not found
         {

          printf("!!!!!!!In the second pass, could not found an index %s in wordlist\n", tokens[i]);
          //fprintf(err_out, "ERROR :In the second pass, could not found an index %s in wordlist\n",sword->a_word);
          //exit(1);
          err++;
         }
        }

     tokens_left++;
    }

 } //end_for



 fprintf(out, "%ld ", tuple_no);
 for (i=0; i<tokens_left; i++)
     {
       //fprintf (out,"token no %d is %s\n",i,final_tokens[i]); // debugging
       fprintf (out,"%s ",final_tokens[i]); // debugging
       fflush(out);

     }
     fprintf(out, "\n");


}

int time_diff(struct timeval *finish, struct timeval *start)
/* time difference in miliseconds */
{
  int time_in_sec, time_in_usec;

  // commented at case!
  //time_in_sec = finish->tv_sec - start->tv_sec;
  //time_in_usec = finish->tv_usec - start->tv_usec;


  return (time_in_sec * 1000) + (time_in_usec / 1000);
} /* time_diff */

/*
int
random_int (int max)
{
  if (max == 0) return (0);
  return (random()%max);
}

*/
void closer(char *open_tag, char *close_tag)
{
   int i;
   close_tag[0] = '<';
   close_tag[1] = '/';

   i=1;
   while (open_tag[i] != NULL)
   {
      close_tag[i+1] = open_tag[i];
      i++;
   }

   close_tag[i+1] = NULL;

}

void extract_header(char *header, char *line)
{

  int i;

  //printf("input: %s\n", line);

  i=0;

  if (line[i]!= '<')
  {
      header[i] = NULL;
      return;
  }
  else
  {
      //printf("here\n");
      //printf("char0 is %c\n",line[5]);
      while (line[i] != ' ' && line[i] != '>')
      {
         //printf("char is %c\n",line[i]);
         header[i] = line[i];
         i++;
         //printf("loop\n");
      }
  }

  header[i] ='>';
  i++;
  header[i] = NULL;
  return;

} /* extract_header */

void extract_content(char *line, char *content)
{
   // do real extraction
   char tmp[MAX_TUPLE_LENGTH];
   int i, j;
   int opened; // to denote if a tag is open or not

   opened = 0;
   j=0;

   for (i=0; i<strlen(line); i++)
   {
     if (line[i] == '<')
        opened = 1;
     else if (line[i] == '>')
        opened = 0;
     else if (!opened)
     {
        tmp[j] = line[i];
        j++;
     }
   }
   tmp [j] = NULL;

   strcpy(content, tmp);
}

// initializes the doc vector for the *current* doc
void initialize_doc_vec(int d_size)
{
 int i;

 // just to be safe, I made <=
 for (i=0; i<=d_size; i++)
 {
   strcpy(DVector[i].word,"");
   DVector[i].index = -1;
   DVector[i].rank_in_doc = -1;
   DVector[i].address = -1;
 }

}


// compute vector length
double dvec_length(int size)
{
 int i;
 double sum;

 //notice DVector is global
 sum = 0;

 for (i=0; i<size; i++)
     sum += DVector[i].term_weight * DVector[i].term_weight;

 return (sqrt(sum));
}


void dvec_normalize (int size)
{
    int i;
    double length;

    length = dvec_length(size);


    for (i=0; i<size; i++)
         DVector[i].term_weight = DVector[i].term_weight/length;

}

void initialize_accumulator()
{
 int i;

 for (i=0; i<DOC_NUM; i++)
 {
      accumulator[i].doc_index = i; // index is itself
      accumulator[i].sim_rank = 0;
 }

}

 // sorts in decreasing order
int ordering (RP p, RP q)
{
  if (p->sim_rank > q->sim_rank)
     return -1;
  if (p->sim_rank < q->sim_rank)
     return 1;
  return 0;
}

void run_ranking_query(DocVec *q_vec, int q_size, int q_no)
{
 int i, j;
 long int address;

 total_list_length = 0;
 total_node_access = 0;

 // clean accumulator array for each query
 initialize_accumulator();

 fprintf(out, "Processing Q %d\n", q_no);
 for (i=0; i<q_size; i++)
 {
   address = WordList[q_vec[i].index].disk_address;
   fseek(entry_ifp, address, 0);
   fread(buffer, sizeof(InvEntry), WordList[q_vec[i].index].occurs_in_docs, entry_ifp);

   total_list_length += WordList[q_vec[i].index].occurs_in_docs;

   for (j=0; j<WordList[q_vec[i].index].occurs_in_docs; j++)
        {

         //fprintf(out, "BAK for term %s: doc id %d weight_in_doc %lf\n",WordList[q_vec[i].index].a_word, buffer[j].doc_id,buffer[j].weight);
         // add accumulator doc_weight * q_term weight
         accumulator[buffer[j].doc_id].sim_rank += (buffer[j].weight * q_vec[i].term_weight);
         total_node_access++;
         }

  }// outer_for

  // theh below work can be done more efficiently using heaps etc.
  // sort accum in decreasing order,choose top n, put in result vector
  // OLMAD, doc id yi kaybederim boyle olursa...-> indexi de tuttum, ok now...
  qsort(accumulator, DOC_NUM, sizeof(accumulator[0]),ordering);

  for (j=0; j<TOP_N; j++)
  {  //fprintf(out, "q_no %d accum index %d %lf\n",q_no, accumulator[j].doc_index, accumulator[j].sim_rank  );
     results[q_no][j].doc_index = accumulator[j].doc_index;
     results[q_no][j].sim_rank = accumulator[j].sim_rank;
     fprintf(out, "q_no %d in the result: doc id %d %lf\n",q_no, results[q_no][j].doc_index, results[q_no][j].sim_rank);
  }

  // print statistics
    fprintf(out, "While processing %d:", q_no);
    fprintf(out, "Total query terms (lists) processed: %d\n", q_size);
    fprintf(out, "Sum of lengths of corresponding inverted lists: %d\n", total_list_length);
    fprintf(out, "Total no of list nodes processed/accessed(clearly equal to above): %d\n",total_node_access);

    sum_list_length += total_list_length;
    sum_node_access += total_node_access;


} //func

void process_ranked_query(char * rel_name)
{
  char line[MAX_TUPLE_LENGTH];
  long int tmp;
  int  i,j,k,p;
  char temp_line[MAX_TUPLE_LENGTH];
  char content[MAX_TUPLE_LENGTH];

  int max_tf;
  DocVec q_vec[QSIZE];

  long int token_freq, next;
  int count;

  //keep the header tag for a line
  char header[30];

  char open_tag[30], close_tag[30];

  char doc_id[20];

   //open input file
  if (!(ifp = fopen(rel_name, "rt")))
  {
      printf("file not found!\n");
      return;
  }

  tmp=0;


  // Now, I consider my data file as I only have R,
  // and run the code fragments written for only R
  processing_R = 1;

  //fgets(line, MAX_TUPLE_LENGTH, ifp); // read <xml version...>
  //fgets(line, MAX_TUPLE_LENGTH, ifp); // read doctype...

  // I changed file format  start with two blank lines

  fgets(line, MAX_TUPLE_LENGTH, ifp); // read blank line
  line[strlen(line)-1]=NULL;

  extract_header(header, line); // should be NULL

  // NOTE: considering school i don't use stricmp!


  while (!feof(ifp))
  {
     fgets(line, MAX_TUPLE_LENGTH, ifp); // read second blank line

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read <top> line
     line[strlen(line)-1]=NULL;
     extract_header(header, line); // should be <top>


     if (strcmp(header,"<top>") == 0)
     {
       printf("ok, I see a new query starts!\n");
       tmp++;
     }
     else
      {
      printf("file structure mismatch error!!!");
      //fprintf(err_out,"ERROR file structure mismatch error!!!");
      exit(1);
      }

      //exit(1);

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read a blank line

     fgets(line, MAX_TUPLE_LENGTH, ifp); // expect to read query number
     line[strlen(line)-1]=NULL;
     extract_header(header, line);


     if (strcmp(header, "<num>")==0)
        {
         extract_content(line, content);
         strcpy(doc_id, content);
         printf("aha %s\n", doc_id);
         }
     else
         {
         printf("Could not read document id?\n");
         //fprintf(err_out, "ERROR Could not read document id?\n");
         exit(1);
         }

     fgets(line, MAX_TUPLE_LENGTH, ifp); // read <title>
     line[strlen(line)-1]=NULL;
     extract_header(header, line);

            // do smt with ifs...
            if (strcmp(header, "<title>")==0)
            {

            extract_content(line, content);
            //process content
            if (USE_TITLE)
            {
            process_tuple(content, doc_no);
            printf("al title%s\n", content);
            }


             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first headline line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);

             while(strcmp(header, "<desc>")!=0)
             {

              extract_content(line, content);
              //process second line of title if exists
              if (USE_TITLE)
              {
              process_tuple(content, doc_no);
              printf("al title %s\n", content);
              }
              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

             } // end_while


            } // if for title

            if (strcmp(header, "<desc>")==0)
            {

             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first headline line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);


             while(strcmp(header, "<narr>")!=0)
             {

               extract_content(line, content);
               // process a description line
               if (USE_DESC)
               {
               process_tuple(content, doc_no);
               printf("desc; %s\n", content);
               }

              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

              } // end_while

            } //if for desc

           if (strcmp(header, "<narr>")==0)
            {

             fgets(line, MAX_TUPLE_LENGTH, ifp);// read first line
             line[strlen(line)-1]=NULL;
             extract_header(header, line);


             while(strcmp(header, "</top>")!=0)
             {

               extract_content(line, content);
               // process a description line
               if (USE_NARR)
               {
               process_tuple(content, doc_no);
               printf("narr; %s\n", content);
               }

              fgets(line, MAX_TUPLE_LENGTH, ifp);// read
              line[strlen(line)-1]=NULL;
              extract_header(header, line);

              } // end_while

            } //if for narrative


            // finished processing a query
            // do smt here with the query
            qsort(DVector,d_size,sizeof(DVector[0]),index_order);

            count = 0;
            token_freq=1;   // the freq. of a given token is set to 1 initially
            max_tf = -1;

            for (i=0; i<d_size; i++)
            {

               next = i+1;

               // I rely on short cut evaluation for the first expresion of if clause!
               if ( next<d_size && DVector[i].index==DVector[next].index)
                  token_freq++;

               else //now I will set the weight entry for a seen token
               {

               // put doc into final array or find weight

               q_vec[count].index = DVector[i].index;
               q_vec[count].rank_in_doc = token_freq; //DVector[i].rank_in_doc;
               // weight for query terms is n * CFC
               //q_vec[count].term_weight = q_vec[count].rank_in_doc * WordList[q_vec[count].index].CFCweight;
               //q_vec[count].address = WordList[q_vec[count].index].disk_address;

               // process the query for tis term...


               // set this to 1 for the next token

               count++;
               token_freq = 1;
               }  //else_part

               if (token_freq>max_tf)
                  max_tf = token_freq; //for weighting purposes

             } //for_ends

     fprintf(out, "max_tf for q_vector %d is %d\n",doc_no, max_tf);
     // set query weights
     for (i=0; i<count; i++)
     {
         // Indeed a term with rank 0 can not be in this vector...
         if (q_vec[i].rank_in_doc != 0)
                  q_vec[i].term_weight = (0.5 + 0.5 * (q_vec[i].rank_in_doc/max_tf)) * WordList[q_vec[i].index].CFCweight;
         else
                  q_vec[i].term_weight = 0;

         fprintf(out, "index %d tf %d CFC %lf q_weight %lf\n", q_vec[i].index, q_vec[i].rank_in_doc,WordList[q_vec[i].index].CFCweight, q_vec[i].term_weight);
         fflush(out);
     }

    u_cleartimer(process_time);
    u_starttimer(process_time);

     //time(&tstart);

     // run the query
     for (p=0; p<RUN_NO; p++)
         run_ranking_query(q_vec, count, doc_no);

     //time(&tend);
     //tsum += tend - tstart;
    u_stoptimer(process_time);

    t_sum += process_time->time;

    fprintf(out,"query:%d process time: %11.3lf\n",doc_no, process_time->time);

     // clear the used part of doc vector
     initialize_doc_vec(d_size); // so I avoid fully initializing the doc vec each time
     d_size = 0;
     doc_no++;
     //current_doc_id = doc_no;


     fgets(line, MAX_TUPLE_LENGTH, ifp);// read either EOF or blank
     //exit(1);


  }// end_while

  fclose (ifp);

  printf("Doc no: %ld %ld\n", doc_no, tmp);

}

int ord_ordering (int * p, int * q)
{
  if (*p > *q)
     return 1;
  if (*p < *q)
     return -1;
  return 0;
}

void evaluate_ranked_query(char * rel_name)
{
  char line[MAX_TUPLE_LENGTH];
  long int tmp;
  int  i,j,k;
  int *value;
  int key;
  char temp_line[MAX_TUPLE_LENGTH];
  char content[MAX_TUPLE_LENGTH];
  int t1, t2, doc_number;
  double precision =0;
  double recall=0;
  double current_recall = 0;

  double prec_sum = 0;
  double current_prec = 0;
  int top_res;

  int max_tf;
  int q_id, all_rel;

  int ret_and_rel =0;
  double avg_prec= 0;

  DocVec q_vec[QSIZE];

  long int token_freq, next;
  int count;

  //keep the header tag for a line
  char header[30];

  char open_tag[30], close_tag[30];

  char doc_id[20];

  char f_name[15];

  char *m;

  //strcpy(f_name, "Qres");
  m = malloc(sizeof(char)*10);

  // initialize the PR values
  init_PR();
  init_Interpolated_PR();
   //open input file
  if (!(j_ifp = fopen(rel_name, "rt")))
  {
      printf("file not found!\n");
      return;
  }

  for (i=0; i<QUERY_NO; i++)
  {
      strcpy(f_name, "Qres");
      sprintf(m,"%d",i);
       strcat(f_name,m);
      strcat(f_name,".txt");

      record_out = fopen(f_name, "wt");
      ret_and_rel = 0;
      fscanf(j_ifp, "%d %d\n", &q_id, &all_rel);
      for (j=0; j<all_rel; j++)
      {
         fscanf(j_ifp, "%d %s %d %d\n", &t1, &temp_line, &t2,&(relevants[j]));
         printf("%d %s %d %d\n", t1, temp_line, t2,relevants[j]);
      }

      // I do this as i could not search 2-dim array
      /*
      for (j=0; j<TOP_N; j++)
      {
         temporary[j].index = results[i][j].doc_index;
         temporary[j].sim_rank = results][i][j].sim_rank;
      }
      */

      // in relevants, check for result, if found increase
      for (j=0; j<TOP_N; j++)
      {
         //strcpy(sword->a_word,tokens[i]);
         //printf("%s ariyorum...\n", sword->a_word);
         //key = malloc(sizeof(int));
         value = malloc(sizeof(int));

         key = results[i][j].doc_index;
         /*
         if (key==348 && relevants[0]==348)
         {   printf("AHAAAAAAAAA %d \n", all_rel);
             //exit(1);
         }
         */
         value = (int *) bsearch(&key, relevants, all_rel, sizeof(int), ord_ordering);

         if (value)
         {
            ret_and_rel ++;

        current_prec += (double) ret_and_rel / (j+1);

        // recall at that moment, we will use these for plotting...
        if (all_rel != 0)
            current_recall = ((double) ret_and_rel) / all_rel;
        else
            current_recall = 0;

        fprintf(record_out, "rank %d prec %lf recal %lf\n", j, (double) ret_and_rel / (j+1), current_recall);
        PR_values[i].prec[j] = (double) ret_and_rel / (j+1);
        PR_values[i].recall[j] = current_recall;
        fprintf(record_out, "rank %d prec %lf recal %lf\n", j,PR_values[i].prec[j] ,PR_values[i].recall[j] );
            //fprintf(eval_out, "%d ",*value);
            //exit(1);
         }
         else
         {
            if (all_rel != 0)
               current_recall = ((double) ret_and_rel) / all_rel;
            else
                current_recall = 0;

            fprintf(record_out, "rank %d prec %lf recal %lf\n", j, (double) ret_and_rel / (j+1), current_recall);
            PR_values[i].prec[j] = (double) ret_and_rel / (j+1);
            PR_values[i].recall[j] = current_recall;
            fprintf(record_out, "rank %d prec %lf recal %lf\n", j,PR_values[i].prec[j] ,PR_values[i].recall[j] );
         } //else
         //exit(1);
      } //end for

  //fprintf(eval_out, "\n");

  top_res = TOP_N;
  precision = ((double) ret_and_rel)/ top_res;


  if (all_rel != 0)
    recall = ((double) ret_and_rel) / all_rel;
  else
    recall = 0;
  fprintf(eval_out, "q_no %d precision %lf recall %lf\n",i, precision, recall);

  if (ret_and_rel)
    avg_prec = current_prec/ret_and_rel;

  prec_sum += avg_prec;

  fprintf(eval_out, "q_no %d  current %lf contributing the avg prec of %lf\n",i, current_prec, avg_prec);

  fclose(record_out);

  avg_prec = 0;

  current_prec = 0;


  } // outer loop

  // call the interplation function
  interpolate_PR();

  print_Interpolated_PR();

  fprintf(eval_out, "mean avg precision is %lf\n", prec_sum/QUERY_NO);

}// func

main() //(int argc,char *argv[])
{
  int i,j,k, t;
  char file_name[15], file_name2[15];
  char *f,*r, *m, pre, end;
  int FileNumber[13];
  int file_index;
  char line[MAX_TUPLE_LENGTH];
  char str[TOKEN_SIZE];
  int rank;

  long int address;

  /*
  if (argc!= 2)
  {
    printf("Usage: <exe_name> <window_size>\n");
    exit(0);
  } */


  // ***I do this here as I will process multi-file
  out = fopen("fs-log.txt", "wt");
  //d_out = fopen("dvec.txt","wt");

  //d_out = fopen("qvec.txt","wt");


  printf("system v1.0\n");

  //err_out = fopen("indexer-logs.txt", "wt");

  ifp = fopen("stopword.lst","rt") ;

  for (i=0;i<NOSTOPWORD;i++)
    fscanf(ifp,"%s\n",stopwords[i]) ;


  fclose(ifp) ;


   // initialize WordList
   // well I do not need to do that, as I handle it while reading
   // In this version, I keep only the necessary structures for each word:
   // namely; a_Word, occurrs_in_docs, CFCweight and disk_address

   // read stopwords here!!!

  //open file
  if (!(ifp = fopen("wordlist.txt","rt")))
  {
      printf("file not found!\n");
      exit(1);
  }

  // DIKKAT: index 1 den basliyor effectively
  word_no_in_list=1;

  while (!feof(ifp))
  {
      // wordlist format <string blank occurrence_no blank CFCweight eol>

      fscanf (ifp, "%s %d %lf\n", str, &(WordList[word_no_in_list].occurs_in_docs), &(WordList[word_no_in_list].CFCweight)); //&rank);
      strcpy(WordList[word_no_in_list].a_word, str);

      if (word_no_in_list>1)
         WordList[word_no_in_list].disk_address =WordList[word_no_in_list-1].disk_address+(sizeof(InvEntry)*WordList[word_no_in_list-1].occurs_in_docs);
      else
         WordList[word_no_in_list].disk_address = 0;

      word_no_in_list++;

  }

  fclose(ifp);

  // here word_no_in_list-1 as I start from 1
  printf("i initialized the word list with %d words, guys\n", word_no_in_list-1);


  // initialize doc_vector
  // Currently, I am keeping this as an extra structure
  initialize_doc_vec(DOC_SIZE);


    //open file
  if (!(entry_ifp = fopen("entry.txt","rb")))
  {
      printf("file not found!\n");
      exit(1);
  }


  //time start
  // I process all queries at once and return results
  // If desired otherwise, one can put each query in one file and process in a loop
  process_ranked_query("q-topics.txt");
  //end time

  fprintf(out,"Total query process time: %11.3lf\n", t_sum);

  fclose(entry_ifp);
  fclose(out);

  eval_out = fopen("FS_ranked.txt", "wt");

  fprintf(eval_out,"no of results returned: top %d\n", TOP_N);

  // for each query handles, evaluate judgements
  evaluate_ranked_query("judgeso.txt");
  fprintf(eval_out, "avg total list length (over all queries): %lf\n",sum_list_length/(double) QUERY_NO);
  fprintf(eval_out, "avg total node access (over all queries): %lf\n",sum_node_access/(double) QUERY_NO);
  fprintf(eval_out,"Total query process time: %11.3lf\n", t_sum);



  fclose(eval_out);

  // process_ANDquery("q-file.txt");

  printf("finished processing\n");

  fclose(entry_ifp);
//  fclose(out);


}
